/******************************************************************************
 * $Id: include/sysflags.h, v0.01 4:14 02.01.2011 TiN Exp $
 *
 * Copyright (c) 2010, xDevs.com HC1 Microcontroller Software Support
 *
 * Project maintainers:
 *  o Tsemenko Ilya  (ilya@xdevs.com)
 *  o Alex Gurin     (warder@xdevs.com)
 */

#ifndef SYSFLAGS_H
#define SYSFLAGS_H

typedef struct {
    uint8_t             lcd_updated:1;      /* LCD update flag */
    uint8_t             init_complete:1;    /* Initialization of device done flag*/
    uint8_t             usermenu_enter:1;
    uint8_t             usermenu_mode:1;
    uint8_t             engmenu_enter:1;
    uint8_t             engmenu_mode:1;
    uint8_t             servmenu_enter:1;
    uint8_t             servmenu_mode:1;
} system_flags_t;

extern system_flags_t system_flags_ctx;

#define isset_system_flag(obj)      \
    (system_flags_ctx.obj)

#define set_system_flag(obj)        \
    do {                            \
        system_flags_ctx.obj = 1;   \
    } while (0)


#define clr_system_flag(obj)        \
    do {                            \
        system_flags_ctx.obj = 0;   \
    } while (0)

#endif /* SYSFLAGS_H */
